"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateBucketCommand = exports.$Command = void 0;
const middleware_location_constraint_1 = require("@aws-sdk/middleware-location-constraint");
const middleware_endpoint_1 = require("@smithy/middleware-endpoint");
const middleware_serde_1 = require("@smithy/middleware-serde");
const smithy_client_1 = require("@smithy/smithy-client");
Object.defineProperty(exports, "$Command", { enumerable: true, get: function () { return smithy_client_1.Command; } });
const EndpointParameters_1 = require("../endpoint/EndpointParameters");
const Aws_restXml_1 = require("../protocols/Aws_restXml");
class CreateBucketCommand extends smithy_client_1.Command
    .classBuilder()
    .ep({
    ...EndpointParameters_1.commonParams,
    UseS3ExpressControlEndpoint: { type: "staticContextParams", value: true },
    DisableAccessPoints: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" },
})
    .m(function (Command, cs, config, o) {
    return [
        (0, middleware_serde_1.getSerdePlugin)(config, this.serialize, this.deserialize),
        (0, middleware_endpoint_1.getEndpointPlugin)(config, Command.getEndpointParameterInstructions()),
        (0, middleware_location_constraint_1.getLocationConstraintPlugin)(config),
    ];
})
    .s("AmazonS3", "CreateBucket", {})
    .n("S3Client", "CreateBucketCommand")
    .f(void 0, void 0)
    .ser(Aws_restXml_1.se_CreateBucketCommand)
    .de(Aws_restXml_1.de_CreateBucketCommand)
    .build() {
}
exports.CreateBucketCommand = CreateBucketCommand;
