"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UploadPartCopyCommand = exports.$Command = void 0;
const middleware_sdk_s3_1 = require("@aws-sdk/middleware-sdk-s3");
const middleware_ssec_1 = require("@aws-sdk/middleware-ssec");
const middleware_endpoint_1 = require("@smithy/middleware-endpoint");
const middleware_serde_1 = require("@smithy/middleware-serde");
const smithy_client_1 = require("@smithy/smithy-client");
Object.defineProperty(exports, "$Command", { enumerable: true, get: function () { return smithy_client_1.Command; } });
const EndpointParameters_1 = require("../endpoint/EndpointParameters");
const models_1_1 = require("../models/models_1");
const Aws_restXml_1 = require("../protocols/Aws_restXml");
class UploadPartCopyCommand extends smithy_client_1.Command
    .classBuilder()
    .ep({
    ...EndpointParameters_1.commonParams,
    DisableS3ExpressSessionAuth: { type: "staticContextParams", value: true },
    Bucket: { type: "contextParams", name: "Bucket" },
})
    .m(function (Command, cs, config, o) {
    return [
        (0, middleware_serde_1.getSerdePlugin)(config, this.serialize, this.deserialize),
        (0, middleware_endpoint_1.getEndpointPlugin)(config, Command.getEndpointParameterInstructions()),
        (0, middleware_sdk_s3_1.getThrow200ExceptionsPlugin)(config),
        (0, middleware_ssec_1.getSsecPlugin)(config),
    ];
})
    .s("AmazonS3", "UploadPartCopy", {})
    .n("S3Client", "UploadPartCopyCommand")
    .f(models_1_1.UploadPartCopyRequestFilterSensitiveLog, models_1_1.UploadPartCopyOutputFilterSensitiveLog)
    .ser(Aws_restXml_1.se_UploadPartCopyCommand)
    .de(Aws_restXml_1.de_UploadPartCopyCommand)
    .build() {
}
exports.UploadPartCopyCommand = UploadPartCopyCommand;
